<?php

namespace Drupal\cmlmigrations\Controller;

use Drupal\Core\Controller\ControllerBase;
use Drupal\cmlapi\Controller\GetCml;

/**
 * InitMigrations.
 */
class MigrationsController extends ControllerBase {

  /**
   * Init.
   */
  public static function init($cml = FALSE) {
    $result = TRUE;
    // Берём актуальный обмен.
    if (!$cml) {
      $cml = GetCml::actual();
    }
    $status = $cml->field_status->value;
    if (in_array($status, ['new', 'progress'])) {
      // Opts: progress, success, failure.
      if ($migrations = Helper::getMigrations()) {
        $result = self::import($cml, $migrations);
      }
    }
    return $result;
  }

  /**
   * Import.
   */
  private static function import($cml, $migrations) {
    $id = $cml->id();
    // Таймаут default: 1 час.
    $timeout_min = \Drupal::config('cmlmigrations.settings')->get('timeout');
    $timeout = $cml->changed->value + 60 * $timeout_min;
    $status = $cml->field_status->value;
    \Drupal::logger(__CLASS__)->notice("go: $id = $status");
    // Первое обращение к обмену - меняем статус и запускаем.
    if ($status == 'new') {
      // Миграции готовы к запуску.
      if ($migrations['status']) {
        // Меняем статус.
        \Drupal::logger(__CLASS__)->notice("ok: $id = $status > progress (exec)");
        $cml->field_status->setValue('progress');
        $cml->save();
        // Запускаем (Дада changed равна времени изменения).
        MigrationsExec::exec('nohup');
        sleep(3);
        return 'progress';
      }
      else {
        // Если мы попали сюда - где-то ошибка.
        \Drupal::logger(__CLASS__)->error("fail: $id = $status > migrations busy");
        $cml->field_status->setValue('failure');
        $cml->save();
        return 'failure';
      }
    }
    // Уже импортируется.
    elseif ($status == 'progress') {
      // Миграция закончилась.
      if ($migrations['status']) {
        \Drupal::logger(__CLASS__)->notice("ok: $id = $status > success (done)");
        $cml->field_status->setValue('success');
        $cml->save();
        return 'success';
      }
      // Миграция ещё не закончилась.
      if ($timeout > REQUEST_TIME) {
        // Пока ок, работаем.
        $time - format_date($timeout - REQUEST_TIME, 'custom', 'H:i:s');
        \Drupal::logger(__CLASS__)->notice("progress: $id / Time: $time");
        return 'progress';
      }
      else {
        // Время вышло.
        \Drupal::logger(__CLASS__)->error("fail: $id = $status > timeout");
        $cml->field_status->setValue('failure');
        $cml->save();
        return 'failure';
      }
    }
    else {
      // Если мы попали сюда - где-то ошибка.
      \Drupal::logger(__CLASS__)->error("fail: $id = $status WTF?");
      $cml->field_status->setValue('failure');
      $cml->save();
    }
    return 'failure';
  }

}
