<?php

namespace Drupal\cmlmigrations\Plugin\migrate\source;

use Drupal\cmlmigrations\MigrationsSourceBase;
use Drupal\cmlapi\Controller\CurrentXmlPath;
use Drupal\cmlapi\Xml\OffersParcer;

/**
 * Source for CSV.
 *
 * @MigrateSource(
 *   id = "cml_commerce_product_variation"
 * )
 */
class CommerceProductVariation extends MigrationsSourceBase {

  /**
   * {@inheritdoc}
   */
  public function getRows() {
    $k = 0;
    $rows = [];
    $filepath = CurrentXmlPath::get('offers');
    $source = OffersParcer::getRows($filepath);
    if ($source) {
      foreach ($source as $key => $row) {
        if ($k++ < 150 || !$this->uipage) {
          $id = $row['Id'];
          $rows[$id] = [
            'type' => 'default',
            'uuid' => $row['Id'],
            'sku' => $row['Id'],
            'product_uuid' => strstr("{$row['Id']}#", "#", TRUE),
            'title' => $row['Naimenovanie'],
            'unit' => $row['BazovaaEdinica'],
            'Kolicestvo' => $row['Kolicestvo'],
            'Sklad' => $row['Sklad'],
            'price' => $row['Ceny'][0]['ЦенаЗаЕдиницу'],
            'ccode' => 'RUB',
          ];
        }
      }
    }
    $this->debug = TRUE;
    return $rows;
  }

}
